diff -urN share-2.0.0.orig/include/blocks.inc.php share/include/blocks.inc.php
--- share-2.0.0.orig/include/blocks.inc.php	2012-05-21 10:07:27.000000000 -0400
+++ share/include/blocks.inc.php	2012-06-28 10:18:50.000000000 -0400
@@ -686,9 +686,9 @@
 	$title->setAttribute('title', _('Only items assigned to enabled hosts are counted'));
 	$table->addRow(array($title, $status['items_count'],
 		array(
-			new CSpan($status['items_count_monitored'], 'off'), ' / ',
-			new CSpan($status['items_count_disabled'], 'on'), ' / ',
-			new CSpan($status['items_count_not_supported'], 'unknown')
+			new CLink($status['items_count_monitored'],'items.php?filter_status=0&filter_set=1&start=0','off'),' / ',
+			new CLink($status['items_count_disabled'],'items.php?filter_status=1&filter_set=1&start=0','unknown'),' / ',
+			new CLink($status['items_count_not_supported'],'items.php?filter_status=3&filter_set=1&start=0','on')
 		)
 	));
 	$title = new CSpan(_('Number of triggers (enabled/disabled)[problem/unknown/ok]'));
diff -urN share-2.0.0.orig/styles/themes/classic/jquery-ui.css share/styles/themes/classic/jquery-ui.css
--- share-2.0.0.orig/styles/themes/classic/jquery-ui.css	2012-05-21 10:07:26.000000000 -0400
+++ share/styles/themes/classic/jquery-ui.css	2012-06-28 13:24:36.000000000 -0400
@@ -39,6 +39,22 @@
 .classic .ui-widget-header { border: 1px solid #4E6EA7; background: #4E6EA7 url(images/widget_header.gif) repeat-x top left; color: #ffffff; font-weight: bold; }
 .classic .ui-widget-header a { color: #ffffff; }
 
+/* This is required, otherwise, the css above overwrite the on/off/unknown defaults */
+.classic .ui-widget-content a.off:link      { color:#00AA00; }
+.classic .ui-widget-content a.off:visited   { color:#00AA00; }
+.classic .ui-widget-content a.off:hover     { color:#44CC44; }
+.classic .ui-widget-content a.off:active    { color:#00AA00; }
+
+.classic .ui-widget-content a.on:link       { color:#DC0000; }
+.classic .ui-widget-content a.on:visited    { color:#DC0000; }
+.classic .ui-widget-content a.on:hover      { color:#CC7777; }
+.classic .ui-widget-content a.on:active     { color:#DC0000; }
+
+.classic .ui-widget-content a.unknown:link       { color:#999999; }
+.classic .ui-widget-content a.unknown:visited    { color:#999999; }
+.classic .ui-widget-content a.unknown:hover      { color:#999; }
+.classic .ui-widget-content a.unknown:active     { color:#999999; }
+
 /* Interaction states
 ----------------------------------*/
 .classic .ui-state-default, .classic .ui-widget-content .ui-state-default, .classic .ui-widget-header .ui-state-default { border: 1px solid #9db2cd; background: #f5f8fa url(images/bg_h-hard_85.png) 50% 50% repeat-x; font-weight: bold; color: #5481ab; }
diff -urN share-2.0.0.orig/styles/themes/darkblue/jquery-ui.css share/styles/themes/darkblue/jquery-ui.css
--- share-2.0.0.orig/styles/themes/darkblue/jquery-ui.css	2012-05-21 10:07:26.000000000 -0400
+++ share/styles/themes/darkblue/jquery-ui.css	2012-06-28 10:42:20.000000000 -0400
@@ -65,6 +65,22 @@
 .darkblue .ui-widget-header { border: 1px solid #77b7da; background: #3c759b url(images/bg_i-soft_25.png) 50% 50% repeat-x; color: #ffffff; font-weight: bold; }
 .darkblue .ui-widget-header a { color: #ffffff; }
 
+/* This is required, otherwise, the css above overwrite the on/off/unknown defaults */
+.darkblue .ui-widget-content a.off:link      { color:#00AA00; }
+.darkblue .ui-widget-content a.off:visited   { color:#00AA00; }
+.darkblue .ui-widget-content a.off:hover     { color:#44CC44; }
+.darkblue .ui-widget-content a.off:active    { color:#00AA00; }
+
+.darkblue .ui-widget-content a.on:link       { color:#DC0000; }
+.darkblue .ui-widget-content a.on:visited    { color:#DC0000; }
+.darkblue .ui-widget-content a.on:hover      { color:#CC7777; }
+.darkblue .ui-widget-content a.on:active     { color:#DC0000; }
+
+.darkblue .ui-widget-content a.unknown:link       { color:#999999; }
+.darkblue .ui-widget-content a.unknown:visited    { color:#999999; }
+.darkblue .ui-widget-content a.unknown:hover      { color:#999; }
+.darkblue .ui-widget-content a.unknown:active     { color:#999999; }
+
 /* Interaction states
 ----------------------------------*/
 .darkblue .ui-state-default, .darkblue .ui-widget-content .ui-state-default, .darkblue .ui-widget-header .ui-state-default { border: 1px solid #77b7da; background: #000e19 url(images/bg_h-hard_25.png) 50% 50% repeat-x; font-weight: bold; color: #77b7da; }
diff -urN share-2.0.0.orig/styles/themes/darkorange/jquery-ui.css share/styles/themes/darkorange/jquery-ui.css
--- share-2.0.0.orig/styles/themes/darkorange/jquery-ui.css	2012-05-21 10:07:26.000000000 -0400
+++ share/styles/themes/darkorange/jquery-ui.css	2012-06-28 13:25:08.000000000 -0400
@@ -63,6 +63,22 @@
 .darkorange .ui-widget-header { border: 1px solid #444; background: #4f4f4f url(images/bg_h-hard_30.png) 50% 50% repeat-x; color: #dfdfdf; font-weight: bold; }
 .darkorange .ui-widget-header a { color: #dfdfdf; }
 
+/* This is required, otherwise, the css above overwrite the on/off/unknown defaults */
+.darkorange .ui-widget-content a.off:link      { color:#00AA00; }
+.darkorange .ui-widget-content a.off:visited   { color:#00AA00; }
+.darkorange .ui-widget-content a.off:hover     { color:#44CC44; }
+.darkorange .ui-widget-content a.off:active    { color:#00AA00; }
+
+.darkorange .ui-widget-content a.on:link       { color:#DC0000; }
+.darkorange .ui-widget-content a.on:visited    { color:#DC0000; }
+.darkorange .ui-widget-content a.on:hover      { color:#CC7777; }
+.darkorange .ui-widget-content a.on:active     { color:#DC0000; }
+
+.darkorange .ui-widget-content a.unknown:link       { color:#999999; }
+.darkorange .ui-widget-content a.unknown:visited    { color:#999999; }
+.darkorange .ui-widget-content a.unknown:hover      { color:#999; }
+.darkorange .ui-widget-content a.unknown:active     { color:#999999; }
+
 /* Interaction states
 ----------------------------------*/
 .darkorange .ui-state-default, .darkorange .ui-widget-content .ui-state-default, .darkorange .ui-widget-header .ui-state-default { border: 1px solid #dfdfdf; background: #2f2f2f url(images/bg_g_40_2f2f2f.png) 50% 50% repeat-x; font-weight: bold; color: #dfdfdf; }
diff -urN share-2.0.0.orig/styles/themes/originalblue/jquery-ui.css share/styles/themes/originalblue/jquery-ui.css
--- share-2.0.0.orig/styles/themes/originalblue/jquery-ui.css	2012-05-21 10:07:26.000000000 -0400
+++ share/styles/themes/originalblue/jquery-ui.css	2012-06-28 13:27:02.000000000 -0400
@@ -64,6 +64,22 @@
 .originalblue .ui-widget-header { border: 1px solid #7e9ab4; background: #779dc0 url(images/bg_h-hard_55.png) 50% 50% repeat-x; color: #ffffff; font-weight: bold; }
 .originalblue .ui-widget-header a { color: #ffffff; }
 
+/* This is required, otherwise, the css above overwrite the on/off/unknown defaults */
+.originalblue .ui-widget-content a.off:link      { color:#00AA00; }
+.originalblue .ui-widget-content a.off:visited   { color:#00AA00; }
+.originalblue .ui-widget-content a.off:hover     { color:#44CC44; }
+.originalblue .ui-widget-content a.off:active    { color:#00AA00; }
+
+.originalblue .ui-widget-content a.on:link       { color:#DC0000; }
+.originalblue .ui-widget-content a.on:visited    { color:#DC0000; }
+.originalblue .ui-widget-content a.on:hover      { color:#CC7777; }
+.originalblue .ui-widget-content a.on:active     { color:#DC0000; }
+
+.originalblue .ui-widget-content a.unknown:link       { color:#999999; }
+.originalblue .ui-widget-content a.unknown:visited    { color:#999999; }
+.originalblue .ui-widget-content a.unknown:hover      { color:#999; }
+.originalblue .ui-widget-content a.unknown:active     { color:#999999; }
+
 /* Interaction states
 ----------------------------------*/
 .originalblue .ui-state-default, .originalblue .ui-widget-content .ui-state-default, .originalblue .ui-widget-header .ui-state-default { border: 1px solid #9db2cd; background: #f5f8fa url(images/bg_h-hard_85.png) 50% 50% repeat-x; font-weight: bold; color: #5481ab; }