diff -Naur zabbix-2.0.4.orig/conf/zabbix_agent.conf zabbix-2.0.4/conf/zabbix_agent.conf
--- zabbix-2.0.4.orig/conf/zabbix_agent.conf	2012-12-08 12:09:14.000000000 +0100
+++ zabbix-2.0.4/conf/zabbix_agent.conf	2012-12-22 13:48:36.000000000 +0100
@@ -1,5 +1,5 @@
 # This is a config file for the Zabbix agent daemon (Unix)
-# To get more information about Zabbix visit http://www.zabbix.com
+# To get more information about Zabbix visit http://www.zabbix.com/
 
 ### Option: Server
 #	IP address of Zabbix server
diff -Naur zabbix-2.0.4.orig/conf/zabbix_agentd.conf zabbix-2.0.4/conf/zabbix_agentd.conf
--- zabbix-2.0.4.orig/conf/zabbix_agentd.conf	2012-12-08 12:09:14.000000000 +0100
+++ zabbix-2.0.4/conf/zabbix_agentd.conf	2012-12-22 13:48:36.000000000 +0100
@@ -1,5 +1,5 @@
 # This is a config file for the Zabbix agent daemon (Unix)
-# To get more information about Zabbix, visit http://www.zabbix.com
+# To get more information about Zabbix, visit http://www.zabbix.com/
 
 ############ GENERAL PARAMETERS #################
 
diff -Naur zabbix-2.0.4.orig/conf/zabbix_agentd.win.conf zabbix-2.0.4/conf/zabbix_agentd.win.conf
--- zabbix-2.0.4.orig/conf/zabbix_agentd.win.conf	2012-12-08 12:09:14.000000000 +0100
+++ zabbix-2.0.4/conf/zabbix_agentd.win.conf	2012-12-22 13:48:36.000000000 +0100
@@ -1,5 +1,5 @@
 # This is a config file for the Zabbix agent daemon (Windows)
-# To get more information about Zabbix, go to http://www.zabbix.com
+# To get more information about Zabbix, go to http://www.zabbix.com/
 
 ############ GENERAL PARAMETERS #################
 
diff -Naur zabbix-2.0.4.orig/conf/zabbix_proxy.conf zabbix-2.0.4/conf/zabbix_proxy.conf
--- zabbix-2.0.4.orig/conf/zabbix_proxy.conf	2012-12-08 12:09:14.000000000 +0100
+++ zabbix-2.0.4/conf/zabbix_proxy.conf	2012-12-22 13:48:36.000000000 +0100
@@ -1,6 +1,6 @@
 # This is a configuration file for Zabbix Proxy process
 # To get more information about Zabbix,
-# visit http://www.zabbix.com
+# visit http://www.zabbix.com/
 
 ############ GENERAL PARAMETERS #################
 
diff -Naur zabbix-2.0.4.orig/conf/zabbix_server.conf zabbix-2.0.4/conf/zabbix_server.conf
--- zabbix-2.0.4.orig/conf/zabbix_server.conf	2012-12-08 12:09:14.000000000 +0100
+++ zabbix-2.0.4/conf/zabbix_server.conf	2012-12-22 13:48:36.000000000 +0100
@@ -1,6 +1,6 @@
 # This is a configuration file for Zabbix Server process
 # To get more information about Zabbix,
-# visit http://www.zabbix.com
+# visit http://www.zabbix.com/
 
 ############ GENERAL PARAMETERS #################
 
diff -Naur zabbix-2.0.4.orig/configure zabbix-2.0.4/configure
--- zabbix-2.0.4.orig/configure	2012-12-08 12:10:07.000000000 +0100
+++ zabbix-2.0.4/configure	2012-12-22 14:04:19.000000000 +0100
@@ -12500,6 +12500,6 @@
 echo "*            Now run '${am_make} install'                       *"
 echo "*                                                         *"
 echo "*            Thank you for using Zabbix!                  *"
-echo "*              <http://www.zabbix.com>                    *"
+echo "*              <http://www.zabbix.com/>                   *"
 echo "***********************************************************"
 echo
diff -Naur zabbix-2.0.4.orig/configure.in zabbix-2.0.4/configure.in
--- zabbix-2.0.4.orig/configure.in	2012-12-08 12:09:24.000000000 +0100
+++ zabbix-2.0.4/configure.in	2012-12-22 14:04:09.000000000 +0100
@@ -1527,6 +1527,6 @@
 echo "*            Now run '${am_make} install'                       *"
 echo "*                                                         *"
 echo "*            Thank you for using Zabbix!                  *"
-echo "*              <http://www.zabbix.com>                    *"
+echo "*              <http://www.zabbix.com/>                   *"
 echo "***********************************************************"
 echo
diff -Naur zabbix-2.0.4.orig/frontends/php/chart4.php zabbix-2.0.4/frontends/php/chart4.php
--- zabbix-2.0.4.orig/frontends/php/chart4.php	2012-12-08 12:09:20.000000000 +0100
+++ zabbix-2.0.4/frontends/php/chart4.php	2012-12-22 13:50:03.000000000 +0100
@@ -174,7 +174,7 @@
 imagerectangle($im, $shiftX, $sizeY + $shiftYup + 39 + 15 * 2, $shiftX + 5, $sizeY + $shiftYup + 35 + 9 + 15 * 2, $black);
 imageText($im, 8, 0, $shiftX + 9, $sizeY + $shiftYup + 15 * 2 + 45, $black, _('Unknown').' (%)');
 
-imagestringup($im, 0, imagesx($im) - 10, imagesy($im) - 50, 'http://www.zabbix.com', $gray);
+imagestringup($im, 0, imagesx($im) - 10, imagesy($im) - 50, 'http://www.zabbix.com/', $gray);
 
 $str = sprintf('%0.2f', microtime(true) - $start_time);
 $str = _s('Generated in %s sec', $str);
diff -Naur zabbix-2.0.4.orig/frontends/php/chart5.php zabbix-2.0.4/frontends/php/chart5.php
--- zabbix-2.0.4.orig/frontends/php/chart5.php	2012-12-08 12:09:20.000000000 +0100
+++ zabbix-2.0.4/frontends/php/chart5.php	2012-12-22 13:50:03.000000000 +0100
@@ -195,7 +195,7 @@
 imagefilledrectangle($im, $shiftX, $sizeY + $shiftYup + 34 + 15 * 2, $shiftX + 5, $sizeY + $shiftYup + 30 + 9 + 15 * 2, $darkred);
 imagerectangle($im, $shiftX, $sizeY + $shiftYup + 34 + 15 * 2, $shiftX + 5, $sizeY + $shiftYup + 30 + 9 + 15 * 2, $black);
 imageText($im, 8, 0, $shiftX + 9, $sizeY + $shiftYup + 15 * 2 + 41, $black, _('PROBLEM').' (%)');
-imagestringup($im, 0, imagesx($im) - 10, imagesy($im) - 50, 'http://www.zabbix.com', $gray);
+imagestringup($im, 0, imagesx($im) - 10, imagesy($im) - 50, 'http://www.zabbix.com/', $gray);
 
 $str = sprintf('%0.2f', microtime(true) - $start_time);
 $str = _s('Generated in %s sec', $str);
diff -Naur zabbix-2.0.4.orig/frontends/php/include/classes/class.cgraphdraw.php zabbix-2.0.4/frontends/php/include/classes/class.cgraphdraw.php
--- zabbix-2.0.4.orig/frontends/php/include/classes/class.cgraphdraw.php	2012-12-08 12:09:18.000000000 +0100
+++ zabbix-2.0.4/frontends/php/include/classes/class.cgraphdraw.php	2012-12-22 13:50:03.000000000 +0100
@@ -263,7 +263,7 @@
 		imagestringup($this->im, 0,
 			$this->fullSizeX - 10,
 			$this->fullSizeY - 50,
-			'http://www.zabbix.com',
+			'http://www.zabbix.com/',
 			$this->getColor('Gray')
 		);
 	}
diff -Naur zabbix-2.0.4.orig/frontends/php/include/classes/class.chelp.php zabbix-2.0.4/frontends/php/include/classes/class.chelp.php
--- zabbix-2.0.4.orig/frontends/php/include/classes/class.chelp.php	2012-12-08 12:09:18.000000000 +0100
+++ zabbix-2.0.4/frontends/php/include/classes/class.chelp.php	2012-12-22 13:56:24.000000000 +0100
@@ -23,7 +23,7 @@
 class CHelp extends CIcon {
 
 	public function __construct() {
-		parent::__construct('http://www.zabbix.com/documentation', 'iconhelp');
+		parent::__construct('http://www.zabbix.com/documentation/', 'iconhelp');
 		parent::onClick('window.open("http://www.zabbix.com/documentation/");');
 	}
 }
diff -Naur zabbix-2.0.4.orig/frontends/php/include/defines.inc.php zabbix-2.0.4/frontends/php/include/defines.inc.php
--- zabbix-2.0.4.orig/frontends/php/include/defines.inc.php	2012-12-08 12:09:18.000000000 +0100
+++ zabbix-2.0.4/frontends/php/include/defines.inc.php	2012-12-22 13:50:03.000000000 +0100
@@ -889,7 +889,7 @@
 // the default theme
 define('ZBX_DEFAULT_THEME', 'originalblue');
 
-define('ZABBIX_HOMEPAGE', 'http://www.zabbix.com');
+define('ZABBIX_HOMEPAGE', 'http://www.zabbix.com/');
 
 // date formats
 define('HISTORY_OF_ACTIONS_DATE_FORMAT', _('d M Y H:i:s'));
diff -Naur zabbix-2.0.4.orig/frontends/php/include/page_footer.php zabbix-2.0.4/frontends/php/include/page_footer.php
--- zabbix-2.0.4.orig/frontends/php/include/page_footer.php	2012-12-08 12:09:18.000000000 +0100
+++ zabbix-2.0.4/frontends/php/include/page_footer.php	2012-12-22 13:50:03.000000000 +0100
@@ -101,7 +101,7 @@
 		$table->addRow(array(
 			new CCol(new CLink(
 				_s('Zabbix %s Copyright %s-%s by Zabbix SIA', ZABBIX_VERSION, ZABBIX_COPYRIGHT_FROM, ZABBIX_COPYRIGHT_TO),
-				'http://www.zabbix.com', 'highlight', null, true), 'center'),
+				'http://www.zabbix.com/', 'highlight', null, true), 'center'),
 			new CCol(array(
 				new CSpan(SPACE.SPACE.'|'.SPACE.SPACE, 'divider'),
 				new CSpan($conString, 'footer_sign')
diff -Naur zabbix-2.0.4.orig/frontends/php/include/views/administration.mediatypes.edit.php zabbix-2.0.4/frontends/php/include/views/administration.mediatypes.edit.php
--- zabbix-2.0.4.orig/frontends/php/include/views/administration.mediatypes.edit.php	2012-12-08 12:09:17.000000000 +0100
+++ zabbix-2.0.4/frontends/php/include/views/administration.mediatypes.edit.php	2012-12-22 14:01:15.000000000 +0100
@@ -44,7 +44,7 @@
 $cmbType->addItemsInGroup(_('Commercial'), array(MEDIA_TYPE_EZ_TEXTING => _('Ez Texting')));
 $cmbTypeRow = array($cmbType);
 if ($this->data['type'] == MEDIA_TYPE_EZ_TEXTING) {
-	$ez_texting_link = new CLink('https://app.eztexting.com', 'https://app.eztexting.com/', null, null, 'nosid');
+	$ez_texting_link = new CLink('https://app.eztexting.com/', 'https://app.eztexting.com/', null, null, 'nosid');
 	$ez_texting_link->setTarget('_blank');
 	$cmbTypeRow[] = $ez_texting_link;
 }
diff -Naur zabbix-2.0.4.orig/frontends/php/include/views/general.browserwarning.php zabbix-2.0.4/frontends/php/include/views/general.browserwarning.php
--- zabbix-2.0.4.orig/frontends/php/include/views/general.browserwarning.php	2012-12-08 12:09:17.000000000 +0100
+++ zabbix-2.0.4/frontends/php/include/views/general.browserwarning.php	2012-12-22 13:48:53.000000000 +0100
@@ -56,7 +56,7 @@
 					New browsers usually come with support for new technologies, increasing web page speed, better privacy settings and so on. They also resolve security and functional issues.
 				</div>
 				<div style="position: absolute; top: 420px; left: 23px;" class="browserwarningCopyright">
-					<a href="http://www.zabbix.com">Zabbix <?php echo ZABBIX_VERSION; ?> Copyright 2001-2012 by Zabbix SIA</a>
+					<a href="http://www.zabbix.com/">Zabbix <?php echo ZABBIX_VERSION; ?> Copyright 2001-2012 by Zabbix SIA</a>
 				</div>
 				<div style="position: absolute; top: 400px; left: 400px;" class="browserwarningLink"><a href="index.php" onClick="javascript: document.cookie='browserwarning_ignore=yes';">Continue despite this warning</a> &raquo;</div>
 			</div>
diff -Naur zabbix-2.0.4.orig/frontends/php/include/views/general.login.php zabbix-2.0.4/frontends/php/include/views/general.login.php
--- zabbix-2.0.4.orig/frontends/php/include/views/general.login.php	2012-12-08 12:09:17.000000000 +0100
+++ zabbix-2.0.4/frontends/php/include/views/general.login.php	2012-12-22 14:00:53.000000000 +0100
@@ -35,9 +35,9 @@
 	<div style="position: relative; color: #F0F0F0; height: 100%;">
 		<!-- Help & Support -->
 		<div style="position: absolute; top: 0px; right: 10px;">
-			<a class="highlight" href="http://www.zabbix.com/documentation"><?php echo _('Help'); ?></a>
+			<a class="highlight" href="http://www.zabbix.com/documentation/><?php echo _('Help'); ?></a>
 			&nbsp;|&nbsp;
-			<a class="highlight" href="https://support.zabbix.com"><?php echo _('Support'); ?></a>
+			<a class="highlight" href="https://support.zabbix.com/"><?php echo _('Support'); ?></a>
 		</div>
 		<!-- Copyright -->
 		<div style="float: left; width: 250px; height: 100%;">
diff -Naur zabbix-2.0.4.orig/misc/win32floppy/install.bat zabbix-2.0.4/misc/win32floppy/install.bat
--- zabbix-2.0.4.orig/misc/win32floppy/install.bat	2012-12-08 12:09:17.000000000 +0100
+++ zabbix-2.0.4/misc/win32floppy/install.bat	2012-12-22 13:50:55.000000000 +0100
@@ -5,7 +5,7 @@
 REM Written by Eugene Grigorjev, Nov 2005
 REM email: eugene.grigorjev@zabbix.com
 
-ECHO Installation script for Windows Zabbix Agent [ http://www.zabbix.com ]
+ECHO Installation script for Windows Zabbix Agent [ http://www.zabbix.com/ ]
 ECHO.
 ECHO Welcome to Zabbix Agent installation!
 ECHO.
@@ -68,7 +68,7 @@
 REM =================== START OF CONFIGURATION FILE =============================
 REM =============================================================================
 ECHO # This is config file for zabbix_agentd > "%Configfile%"
-ECHO # To get more information about ZABBIX, go http://www.zabbix.com >> "%Configfile%"
+ECHO # To get more information about ZABBIX, go http://www.zabbix.com/ >> "%Configfile%"
 ECHO. >> "%Configfile%"
 ECHO ############ GENERAL PARAMETERS ################# >> "%Configfile%"
 ECHO. >> "%Configfile%"
@@ -191,7 +191,7 @@
 ECHO   Now You can configure Zabbix Server to monitor this PC.
 ECHO.
 ECHO            Thank You for using Zabbix software.
-ECHO                  http://www.zabbix.com
+ECHO                  http://www.zabbix.com/
 ECHO #############################################################
 ECHO.
 
diff -Naur zabbix-2.0.4.orig/misc/win32floppy/README zabbix-2.0.4/misc/win32floppy/README
--- zabbix-2.0.4.orig/misc/win32floppy/README	2012-12-08 12:09:17.000000000 +0100
+++ zabbix-2.0.4/misc/win32floppy/README	2012-12-22 13:48:36.000000000 +0100
@@ -60,4 +60,4 @@
 AUTHOR
 	Eugene Grigorjev, Nov 2005
 	eugene.grigorjev@zabbix.com
-	http://www.zabbix.com
+	http://www.zabbix.com/
diff -Naur zabbix-2.0.4.orig/misc/win32floppy/uninstall.bat zabbix-2.0.4/misc/win32floppy/uninstall.bat
--- zabbix-2.0.4.orig/misc/win32floppy/uninstall.bat	2012-12-08 12:09:17.000000000 +0100
+++ zabbix-2.0.4/misc/win32floppy/uninstall.bat	2012-12-22 13:50:55.000000000 +0100
@@ -5,7 +5,7 @@
 REM Written by Eugene Grigorjev, Nov 2005
 REM email: eugene.grigorjev@zabbix.com
 
-ECHO Uninstallation script for Windows Zabbix Agent [ http://www.zabbix.com ]
+ECHO Uninstallation script for Windows Zabbix Agent [ http://www.zabbix.com/ ]
 ECHO.
 ECHO Welcome to Zabbix Agent uninstallation!
 ECHO.
@@ -47,7 +47,7 @@
 ECHO           Zabbix Agent log file (see config file)
 ECHO           Zabbix Agent config file
 ECHO.
-ECHO                  http://www.zabbix.com
+ECHO                  http://www.zabbix.com/
 ECHO.
 ECHO #############################################################
 ECHO.