diff -Nur zabbix/events.php zabbix_menu/events.php
--- zabbix/events.php	2012-12-08 12:09:20.000000000 +0100
+++ zabbix_menu/events.php	2013-02-19 11:46:33.602972459 +0100
@@ -664,6 +664,7 @@
 				'hostids' => $hostids,
 				'selectAppllications' => API_OUTPUT_EXTEND,
 				'selectScreens' => API_OUTPUT_COUNT,
+				'selectGraphs' => API_OUTPUT_COUNT,
 				'selectInventory' => true,
 				'preservekeys' => true
 			));
diff -Nur zabbix/include/blocks.inc.php zabbix_menu/include/blocks.inc.php
--- zabbix/include/blocks.inc.php	2012-12-08 12:09:18.000000000 +0100
+++ zabbix_menu/include/blocks.inc.php	2013-02-19 11:25:14.979637556 +0100
@@ -806,6 +806,7 @@
 		'output' => array('hostid', 'name', 'maintenance_status', 'maintenance_type', 'maintenanceid'),
 		'selectInventory' => true,
 		'selectScreens' => API_OUTPUT_COUNT,
+		'selectGraphs' => API_OUTPUT_COUNT,
 		'preservekeys' => true
 	));
 
diff -Nur zabbix/include/hosts.inc.php zabbix_menu/include/hosts.inc.php
--- zabbix/include/hosts.inc.php	2012-12-08 12:09:18.000000000 +0100
+++ zabbix_menu/include/hosts.inc.php	2013-02-19 11:06:57.926850735 +0100
@@ -1323,6 +1323,7 @@
 		'scripts' => $menuScripts,
 		'hostid' => $host['hostid'],
 		'hasScreens' => (bool) $host['screens'],
+		'hasGraphs' => (bool) $host['graphs'],
 		'hasInventory' => (bool) $host['inventory']
 	);
 }
diff -Nur zabbix/include/items.inc.php zabbix_menu/include/items.inc.php
--- zabbix/include/items.inc.php	2012-12-08 12:09:18.000000000 +0100
+++ zabbix_menu/include/items.inc.php	2013-02-19 11:50:25.253932394 +0100
@@ -676,6 +676,7 @@
 	$hosts = API::Host()->get(array(
 		'output' => array('name', 'hostid'),
 		'selectScreens' => API_OUTPUT_COUNT,
+		'selectGraphs' => API_OUTPUT_COUNT,
 		'selectInventory' => true,
 		'monitored_hosts' => true,
 		'hostids' => $hostids,
diff -Nur zabbix/include/maps.inc.php zabbix_menu/include/maps.inc.php
--- zabbix/include/maps.inc.php	2012-12-08 12:09:18.000000000 +0100
+++ zabbix_menu/include/maps.inc.php	2013-02-19 12:04:06.376646951 +0100
@@ -94,6 +94,7 @@
 		'nopermissions' => true,
 		'preservekeys' => true,
 		'selectScreens' => API_OUTPUT_COUNT,
+		'selectGraphs' => API_OUTPUT_COUNT
 	));
 
 	foreach ($sysmap['selements'] as $elem) {
@@ -117,12 +118,14 @@
 			'elementType' => $elem['elementtype'],
 			'scripts' => array(),
 			'hasScreens' => false,
+			'hasGraphs' => false,
 			'isMonitored' => false
 		);
 		if ($elem['elementtype'] == SYSMAP_ELEMENT_TYPE_HOST) {
 			$host = $hosts[$elem['elementid']];
 			$menuData['scripts'] = $scripts_by_hosts[$elem['elementid']];
 			$menuData['hasScreens'] = (bool) $host['screens'];
+			$menuData['hasGraphs'] = (bool) $host['graphs'];
 			$menuData['isMonitored'] = $hosts[$elem['elementid']]['status'] == HOST_STATUS_MONITORED;
 		}
 		$area->setAttribute('data-menu', $menuData);
diff -Nur zabbix/include/triggers.inc.php zabbix_menu/include/triggers.inc.php
--- zabbix/include/triggers.inc.php	2012-12-08 12:09:18.000000000 +0100
+++ zabbix_menu/include/triggers.inc.php	2013-02-19 11:24:08.034658176 +0100
@@ -1154,6 +1154,7 @@
 		'output' => array('name', 'hostid'),
 		'hostids' => $hostids,
 		'selectScreens' => API_OUTPUT_COUNT,
+		'selectGraphs' => API_OUTPUT_COUNT,
 		'selectInventory' => true,
 		'preservekeys' => true
 	));
@@ -1624,6 +1625,7 @@
 		'hostids' => $trigger['hosts'][0]['hostid'],
 		'selectAppllications' => API_OUTPUT_EXTEND,
 		'selectScreens' => API_OUTPUT_COUNT,
+		'selectGraphs' => API_OUTPUT_COUNT,
 		'selectInventory' => true,
 		'preservekeys' => true
 	));
diff -Nur zabbix/include/views/js/monitoring.maps.js.php zabbix_menu/include/views/js/monitoring.maps.js.php
--- zabbix/include/views/js/monitoring.maps.js.php	2012-12-08 12:09:17.000000000 +0100
+++ zabbix_menu/include/views/js/monitoring.maps.js.php	2013-02-19 12:19:24.786965128 +0100
@@ -22,11 +22,15 @@
 
 				if (menuData.isMonitored) {
 					linkMenu.push(createMenuItem(<?php echo CJs::encodeJson(_('Status of triggers')) ?>,
-						'tr_status.php?hostid=' + menuData.elementId));
+						'tr_status.php?groupid=0&hostid=' + menuData.elementId));
 
 					if (menuData.hasScreens) {
 						linkMenu.push(createMenuItem(<?php echo CJs::encodeJson(_('Host screens')) ?>,
-							'host_screen.php?hostid=' + menuData.elementId));
+							'host_screen.php?groupid=0&hostid=' + menuData.elementId));
+					}
+					if (menuData.hasGraphs) {
+						linkMenu.push(createMenuItem(<?php echo CJs::encodeJson(_('Graphs')) ?>,
+							'charts.php?groupid=0&hostid=' + menuData.elementId));
 					}
 				}
 			}
diff -Nur zabbix/js/init.js zabbix_menu/js/init.js
--- zabbix/js/init.js	2012-12-08 12:09:17.000000000 +0100
+++ zabbix_menu/js/init.js	2013-02-19 12:17:43.905669541 +0100
@@ -47,12 +47,15 @@
 
 		// add go to links
 		menu.push(createMenuHeader(t('Go to')));
-		menu.push(createMenuItem(t('Latest data'), 'latest.php?hostid=' + menuData.hostid));
+		menu.push(createMenuItem(t('Latest data'), 'latest.php?groupid=0&hostid=' + menuData.hostid));
+		if (menuData.hasGraphs) {
+			menu.push(createMenuItem(t('Graphs'), 'charts.php?groupid=0&hostid=' + menuData.hostid));
+		}
 		if (menuData.hasInventory) {
 			menu.push(createMenuItem(t('Host inventories'), 'hostinventories.php?hostid=' + menuData.hostid));
 		}
 		if (menuData.hasScreens) {
-			menu.push(createMenuItem(t('Host screens'), 'host_screen.php?hostid=' + menuData.hostid));
+			menu.push(createMenuItem(t('Host screens'), 'host_screen.php?groupid=0&hostid=' + menuData.hostid));
 		}
 
 		// render the menu
diff -Nur zabbix/latest.php zabbix_menu/latest.php
--- zabbix/latest.php	2012-12-08 12:09:20.000000000 +0100
+++ zabbix_menu/latest.php	2013-02-19 11:38:08.028696052 +0100
@@ -210,6 +210,7 @@
 	'selectAppllications' => API_OUTPUT_EXTEND,
 	'selectScreens' => API_OUTPUT_COUNT,
 	'selectInventory' => true,
+	'selectGraphs' => API_OUTPUT_COUNT,
 	'selectGroups' => API_OUTPUT_REFER,
 	'preservekeys' => true
 );
diff -Nur zabbix/tr_status.php zabbix_menu/tr_status.php
--- zabbix/tr_status.php	2012-12-08 12:09:20.000000000 +0100
+++ zabbix_menu/tr_status.php	2013-02-19 11:32:03.095674836 +0100
@@ -433,6 +433,7 @@
 		'hostids' => $tr_hostids,
 		'preservekeys' => true,
 		'selectScreens' => API_OUTPUT_COUNT,
+		'selectGraphs' => API_OUTPUT_COUNT,
 		'selectInventory' => true
 	));
 
@@ -602,6 +603,7 @@
 				'scripts' => $menuScripts,
 				'hostid' => $trigger_host['hostid'],
 				'hasScreens' => (bool) $host['screens'],
+				'hasGraphs' => (bool) $host['graphs'],
 				'hasInventory' => (bool) $host['inventory']
 			));
 